#!/bin/bash -x
pushd ../../segmenter ; make ; popd
pushd ../../recogniser ; make ; popd
# Outside requirements: ocrmypdf pdfimages convert deskew zip

SPACING=( `../../segmenter/findmean < prescan.results` )
echo Using character grid ${SPACING[0]} x ${SPACING[1]}
# We have to re-generate the offsets at the new fixed spacing values,
# then output the gridded page and the lines and the individual chars

cp /dev/null offset.log
for pfilename in level/AA-008.png ; do
    filename="`basename $pfilename .png`"
    if [ -f grid/${filename}@*@*.png ] ; then
        echo Skipping grid/${filename}@*@*.png
    else
      convert $pfilename $filename.pnm
      export LD_LIBRARY_PATH="/usr/local/netpbm/lib"
      PARAMS=( `../../segmenter/reoffset --xstep ${SPACING[1]} --ystep ${SPACING[0]} $filename.pnm` )
      echo $PARAMS >> offset.log
      # getlines should be renamed something like extract,
      # and have the grid calculation part removed.
      # getlines *used to* do the grid determination,
      # but that was moved to segment.c when it was
      # re-written with a better algorithm.
      echo ../../segmenter/getlines --exact-line-spacing=${SPACING[0]} \
           --exact-column-spacing=${SPACING[1]} \
           --line-offset=${PARAMS[2]} \
           --column-offset=${PARAMS[5]} \
           --grid --lines --tiles \
           -v $filename.pnm
      ../../segmenter/getlines --exact-line-spacing=${SPACING[0]} \
           --exact-column-spacing=${SPACING[1]} \
           --line-offset=${PARAMS[2]} \
           --column-offset=${PARAMS[5]} \
           --grid --lines --tiles \
           -v $filename.pnm
      #rm $filename.pnm
      #find tiles/$filename -name 'col???.pgm' | while read f ; do
      #  echo convert $f `dirname $f`/`basename $f .pgm`.png \&\& rm $f
      #  convert $f `dirname $f`/`basename $f .pgm`.png && rm $f
      #done
    fi
    LONGNAME="`basename grid/${filename}@*@*.png .png`"
    if [ -f grid/$filename.html ] ; then
        echo Skipping grid/$filename.html
    else
      convert grid/${filename}*.png ${LONGNAME}.pnm
      ../../segmenter/grid2html ${LONGNAME}.pnm > grid/$filename.html
      rm ${LONGNAME}.pnm
    fi
done

   # if [ -f tiles/$filename.zip ] ; then
   #     echo Skipping zip tiles/$filename.zip
   # else
   #     echo "pushd tiles ; zip -r $filename.zip $filename/line* ; popd"
   #     pushd tiles >& /dev/null ; zip -r $filename.zip $filename/line* ; popd >& /dev/null
   #     rm -rf tiles/$filename/line*
   # fi                               

exit 0
